; MCKwatch	HSP2.60 source code

; program version
; -------------------------------------------------
	ver="MCKwatch ver4.16" : title "boot check."
	screen 0,160,0,0,0,0 : cls 1


; extend source
; -------------------------------------------------
	#include "hspext.as"
	#include "llmod.as"
	#include "obj.as"


; multi working check
; -------------------------------------------------
	aplsel "MCKwatch ver"
	if stat=0 {
		if cmdline!="" {
			aplact : wait 10 : aplkey 115,4
			} else {
			dialog "Already moved.",1,"Multi Move!" : end
			}
		}
	title ver


; inifile include
; -------------------------------------------------
	dim wp,5
	exist "mckwatch.ini"
	if strsize!=-1 {
			bload "mckwatch.ini",wp
			} else {
			wp.0=dispx-326 : wp.1=0
			wp.2=dispx-326 : wp.3=144
			}

;   main window
	screen 0,320,120,0,wp.0,wp.1 : cls 1
	objmode 1,1 : objsize 50,22 : sysfont 17
;   sub window
	screen 2,320,200,0,wp.2,wp.3 : cls 1
	title "MCKW addtion function"
	objmode 1,1 : objsize 50,22 : sysfont 17
	gsel 2,-1 : gsel 0


; paramater initialize
; -------------------------------------------------
	dim ftm,24			; Timestamp (check)
	dim fbk,24			; Timestamp (bkup)

	sdim fullpath,512		; filepath (fullpath)
	sdim fpath,512			; filepath (path only)
	sdim fname,128			; filename (with .***)
	sdim fbat,2049			; mckc batchfile
	sdim errs,1024			; error information view
	sdim err1,20480			; error checksum info A
	sdim err2,64			; error checksum info B
	sdim kcprm,129 : kcprm="-i"	; mckc paramater

	dim pal,33			; Namco106 view paramaters
	sdim f106,10240			; namco106 file list
	sdim w106,128			; Namco106 mml paramaters

	sdim tnorg,1024			; short tone mml ( ?x3 !x4 ... )
	sdim tnmml,2048			; wide tone mml  ( ? ? ? ! ! 1 ! ... )


; directory / import file check
; -------------------------------------------------
	dirlist err2,"mck",5 : charupper err2
	if err2!="MCK\n" : exec "COMMAND.COM /c MD .\\mck",3 : err1+="MCK directory\n"
	dirlist err2,"n106",5 : charupper err2
	if err2!="N106\n" : exec "COMMAND.COM /c MD .\\n106",3 : err1+="N106 directory\n"
	err2=""
	exist ".\\mck\\mckc.exe" : if strsize=-1 : err1+="mckc.exe\n"
	exist ".\\mck\\nesasm.exe" : if strsize=-1 : err1+="nesasm.exe\n"
	exist ".\\mck\\fds.h" : if strsize=-1 : err1+="fds.h\n"
	exist ".\\mck\\n106.h" : if strsize=-1 : err1+="n106.h\n"
	exist ".\\mck\\sounddrv.h" : if strsize=-1 : err1+="sounddrv.h\n"

;  mck version checksum
;  --------------------
	if wp.4=0 {
		exist ".\\mck\\make_nsf.asm" : if strsize!=-1 : wp.4=2
		exist ".\\mck\\make_nsf.txt" : if strsize!=-1 : wp.4=1
		if wp.4=0 : err1+="invalid mck version.\n"
		}
	if wp.4=1 {
		exist ".\\mck\\make_nsf.txt" : if strsize=-1 : err1+="make_nsf.txt\n"
		}
	if wp.4=2 {
		exist ".\\mck\\make_nsf.asm" : if strsize=-1 : err1+="make_nsf.asm\n"
		}

	if err1!="" {
		dialog err1+"\nNot found the file(s) in mck directory.\nPlease check install file(s).",0,"important file checksum"
		if wp.4!=0 : dialog "If you change mck to mck-apu version?\nDelete mckwatch.ini file and restart please.",0,"information" : end
		}
	err2="" : err1="" : errs=""

; namcot106 wave paramater list generate
; -------------------------------------------------
	chdir ".\\n106"
	dirlist f106,"*.106",0
	chdir ".."


; create gui
; -------------------------------------------------

;   main window
	gsel 0
	pos 007,003 : mes "PATH"
	pos 007,043 : mes "MCKC PARAMATER"
	pos 005,019 : mesbox fpath,250,20,2,0	;#0
	pos 005,059 : input kcprm,250,20,128	;#1
	pos 260,019 : button "SET",*BTN		;#2 - targetfile set
	pos 260,090 : button "OFF",*BTN		;#3 - watch mode
	pos 010,090 : button "mckc",*BTN	;#4 - mckc manual view
	pos 080,090 : button "play",*BTN	;#5 - play *.nsf file
	pos 150,090 : button "info",*BTN	;#6 - compile info view
	pos 260,059 : button "show",*BTN	;#7 - addition window view/hide
	objgray 3,0 : objgray 5,0

;   sub window
	gsel 2
	pos 205,015 : mes "N106 wave file"
	objsize 110,20
	pos 200,030 : combox namf,100,f106	;#0 - namcot106 filelist
	objsize 50,22
	pos 260,055 : button "view",*BTN2	;#1 - .106file wave view
	gosub *HOUGAN
	pos 007,115 : mes "SHORT TONE MML ( 15x3 12x5 ... )"
	pos 005,130 : input tnorg,300,22,1023	;#2 - short paramater mml
	pos 260,160 : button "wide",*BTN2	;#3 - wide mml changer

	gsel 0,1
	onkey *KIN : onexit *PRGEND
	if cmdline!="" : goto *FINC
	stop


; shortcut key routine
; -------------------------------------------------
*KIN
	if iparam=112 : exec ".\\mck\\mckc.txt",16
	if iparam=113 : gosub *CMPINFO
	if iparam=116 : goto *NSFPLY
	if iparam=120 : goto *SUBWIN
	if iparam=123 : dialog "programmed by rophon\nspecial thanks : Naruto\n and mckwatch users",0,"About "+ver
	if iparam=27 : goto *PRGEND
	if mod=1 : goto *MAINRTN
	stop


; program complete
; -------------------------------------------------
*PRGEND
	gsel 2 : ginfo 2 : wp.2=prmx : wp.3=prmy
	gsel 0 : ginfo 2 : wp.0=prmx : wp.1=prmy
	bsave "mckwatch.ini",wp
	end


; button pressing
; -------------------------------------------------
*BTN
	gsel 0 : objsel -1 : a=stat
	if a=2 : goto *FLD
	if a=3 : goto *MODWIN
	if a=4 {
		exist ".\\mck\\mckc.txt"
		if strsize!=-1 : exec ".\\mck\\mckc.txt",16
		}
	if a=5 : goto *NSFPLY
	if a=6 : gosub *CMPINFO
	if a=7 : goto *SUBWIN
	stop


; drop-file include
; -------------------------------------------------
*FINC
	gsel 0 : mod=0 : objprm 3,"OFF" : objgray 3,0

	fullpath=cmdline
	goto *FLD2

; capture watch filename
; -------------------------------------------------
*FLD
	gsel 0 : mod=0 : objprm 3,"OFF" : objgray 3,0
	dialog "mml;*.mck;*.txt;*.mus",16,"watch mml source"
	if stat=0 : stop
	fullpath=refstr
*FLD2
	getpath fpath,fullpath,32
	dirlist fname2,fullpath					; gq
	getpath fname,fname2,9					; gqȂ
	objprm 3,"ON" : objgray 3,1 : objprm 0,fname
	fxtget ftm,fullpath : fxtget fbk,fullpath
	mod=1
	exec fullpath,16

	exist fname+".nsf"
	if strsize!=-1 : objgray 5,1

	goto *MAINRTN


; nsf player call and play music
;--------------------------------------------------
*NSFPLY
	gsel 0
	exist fname+".nsf"
	if strsize!=-1 : exec fname+".nsf",16
	if strsize=-1 : objgray 5,0
	if mod=1 : goto *MAINRTN
	stop


; sub window view / hide
; -------------------------------------------------
*SUBWIN
	gsel 0 : swin++
	if swin=1 {
		objprm 7,"hide" : gsel 2,1
		fxtget ftm,fullpath : fxtget fbk,fullpath
		}
	if swin>1 : objprm 7,"show" : gsel 2,-1 : swin=0
	gsel 0
	if mod=0 : stop
	goto *MAINRTN

; watch mode change
; -------------------------------------------------
*MODWIN
	gsel 0 : mod++
	if mod=1 : objprm 3,"ON"
	if mod>1 : objprm 3,"OFF" : mod=0
	if mod=0 : stop
	goto *MAINRTN

; main routine
; --------------------------------------------------
*MAINRTN
	wait 5
	fxtget ftm,fullpath
	x1=0 : x2=8
	repeat 8 : if ftm.x2!=fbk.x2 : x1=1
	x2++ : loop
	if x1=1 : goto *MCKC
	goto *MAINRTN


; compile batchfile generate
; ---------------------------------------------------
*MCKC
	gsel 0
	objgray 3,0 : objgray 4,0 : objgray 5,0 : objgray 6,0 : objgray 7,0
	onkey 0
	fxtget ftm,fullpath : fxtget fbk,fullpath
;   ----------------------------
;   genereate batchfile
;   ----------------------------
	sdim fbat,2049 : errs="" : errs2=""
	fbat+="del _DUMMY_\n"
	fbat+="cd mck\n"
	fbat+="mckc "+kcprm+" ..\\"+fname2+" "+fname+".h > err_mckc.txt\n"
	fbat+="del error.txt\n"
	if wp.4=1 : fbat+="nesasm -raw make_nsf.txt >> error.txt\n"
	if wp.4=2 : fbat+="nesasm -raw make_nsf.asm >> error.txt\n"
	fbat+="ren make_nsf.nes "+fname+".nsf\n"
	fbat+="move "+fname+".nsf ..\n"
	fbat+="cd ..\n"
	fbat+="dir dummy >_DUMMY_\n"
	strlen x1,fbat : bsave "automckc.bat",fbat,x1
	exist fname+".nsf"
	if strsize!=-1 : delete fname+".nsf"
;   ----------------------------
;   batchfile create loop & exec
;   ----------------------------
	repeat
	exist "automckc.bat" : if strsize!=-1 : break
	wait 5 : loop
	exec "automckc.bat",16
;   ----------------------------
;   compile endfile check loop
;   ----------------------------
	repeat
	exist "_DUMMY_" : if strsize!=-1 : break
	wait 5 : loop
	wait 50 : delete "_DUMMY_" : delete "automckc.bat"
	exist fname+".nsf"
	if strsize!-1 : goto *MCKCEND
	errs2="invalid generate "+fname+".nsf file.\n\n"
	gosub *CMPINFO
;   ----------------------------
;   recover dialog mode and setting
;   ----------------------------
*MCKCEND
	objgray 3,1 : objgray 4,1 : objgray 5,1 : objgray 6,1 : objgray 7,1
	onkey 1
	goto *NSFPLY


; compile information
; -----------------------------------------------------
*CMPINFO
	sdim errs,10241 : sdim fbat,2049
	exist ".\\mck\\err_mckc.txt"
	if strsize!=-1 : bload ".\\mck\\err_mckc.txt",errs
	errs=errs2+errs+"\n\n"
	exist ".\\mck\\error.txt"
	if strsize!=-1 : bload ".\\mck\\error.txt",fbat
	errs+=fbat
	dialog ""+errs,0,"compile information"
	errs2=""
	return

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
; : sub window codes
; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; press sub-window button
; -------------------------------------------------------
*BTN2
	gsel 2 : objsel -1 : a=stat
	if a=1 : goto *GET106
	if a=3 : goto *TNWIDE
	if mod=1 : goto *MAINRTN
	stop

; namco106 loader
; -------------------------------------------------------
*GET106
	notesel f106
	noteget fname3,namf
	exist ".\\N106\\"+fname3
	if strsize=-1 : goto *FIN106
	dim pal,33 : sdim w106,128
	wait 1
	bload ".\\N106\\"+fname3,w106
	strmid b,w106,-1,1 : if b!=" " : w106+=" "
	strlen a,w106
	c=0 : b="" : d="" : e="" : x=0 : f=0 : wait 1
	repeat a
	  strmid b,w106,x,1
	  if b=" " :f=0
	  if (b!=" ")&(f=0) {
		strmid d,w106,x+1,1
		if d!=" " : strmid e,w106,x,2
		if d=" " : strmid e,w106,x,1
		int e : if e>15 : e=15
		pal.c=e : str e
		f=1 : c++ : if c>31 : break
		}
	x++
	loop
	wait 1
	clipset w106
	gosub *HOUGAN
*FIN106
	if mod=1 : goto *MAINRTN
	stop

; wave write
; -------------------------------------------------------
*HOUGAN
	gsel 2
	color 196,196,196 : boxf 10,10,200,99
	color 128,0,0 :wait 1
	z=0 : repeat 32
		y=(pal.z*5) : boxf 10+(z*5),89,15+(z*5),89-y
	z++ : loop
	color 0,0,0
	x=0 : y=0
	color 128,128,128
	repeat 16
		line 10,89-(y*5),170,89-(y*5)
		y++ : loop
	repeat 33
		line 10+(x*5),15,10+(x*5),89
		x++ : loop
	color 0,0,0
	return


; shortwrite paramater longer routine
; --------------------------------------------------
*TNWIDE
	gsel 2
	x=0 : y=0 : z=0 : a=0 : b="" : d="" : e="" : f=0 : tnmml=""
	strlen z,tnorg
	strmid b,tnorg,-1,1 : if b!=" " : tnorg+=" "
*TNMAIN
	strmid b,tnorg,x,1
	if (b!=" ")&(f=0) : f=1 : y=x
	if (b=" ")&(f=1) {
		strmid d,tnorg,y,(x-y)
		strlen w,d : f=0
		if w>2 {
			v=0 : t1="" : t2="" : t3=0
			*TNLOOP
			strmid e,d,v,1
			if e="x" {
				strmid t1,d,0,v : strmid t2,d,v+1,w : t3=1
				} else {
				t1=d : t2="1"
				}
			v++ 
			if (v<w)&(t3=0) : goto *TNLOOP
			int t2
			repeat t2 : tnmml+=t1+" " : loop
			str t2
			} else {
				tnmml+=d+" "
			}

	}
	x++ : if x<=z : goto *TNMAIN
	objprm 2,tnmml : wait 1
	clipset tnmml
	if mod=1 : goto *MAINRTN
	stop
