; mck-watch hsp2.61 generate version

	#include "hspext.as"
	#include "llmod.as"
	#include "obj.as"

	sdim mml,32768
	sdim fpath,512 : fpath=curdir+"\\example.mml"
	sdim mpath,512 : getpath mpath,fpath,32
	sdim fnam,32 : fnam="example"
	sdim mkbat,4096 : sdim cprm,512 : sdim dmy,4096
	dim txsiz,4
	dim tso,24
	dim tsbk,24

	title fpath
	screen 0,dispx,dispy,2,0,0 : cls 1
	mref bmscr, 67
	prm = bmscr.13, -16
	dllproc "GetWindowLongA", prm, 2 ,D_USER
	prm.2 = dllret | 0x50000
	dllproc "SetWindowLongA", prm, 3, D_USER
	width 640,480 : xbk=winx : ybk=winy
	objmode 2,0 : objsize 60,20 : font "Arial",12
	
	pos 000,20 : mesbox mml,winx,winy-20,5,32700	;#0
	pos 000,00 : button "load",*btn			;#1
	pos 060,00 : button "save",*btn			;#2
	pos 120,00 : button "complog",*btn		;#3
	pos 180,00 : button "play",*btn			;#4
	pos 240,00 : button "off",*btn			;#5
	pos 310,00 : chkbox "JP lang",jp		;#6
	pos 380,00 : chkbox "mckc-e",en			;#7

	gsel 0,1
; ---------------------
*main
	if (winx!=xbk)|(winy!=ybk) {
		txsiz=winx,winy-20,0,20 : resizeobj 0,txsiz,1
		xbk=winx : ybk=winy
		}

	if (jpbk!=jp) {
		if jp=0 { font "Arial",14 } else { font "lr SVbN",16 }
		clrobj 0,0 : pos 0,20 : mesbox mml,winx,winy-20,5,32700
		jpbk=jp : objsel 0
		}

	exist fpath : if strsize<0 { objgray 5,0 } else  { objgray 5,1 }
	exist mpath+fnam+".nsf" : if strsize<0 { objgray 4,0 } else  { objgray 4,1 }

	if wat=1 {
		fxtget tso,fpath : a=0 : b=0
		repeat 8 : a=cnt+8 : if tso.a!=tsbk.a : b=1
		loop : if b=1 : goto *f_cmp
		}

	wait 5 : goto *main
;----------------------
*btn
	objsel -1 : a=stat
	if a=1 : goto *f_lod
	if a=2 : goto *f_sav
	if a=3 {
		exec exedir+"\\mck\\error.txt",16
		exec exedir+"\\mck\\errkc.txt",16
		}
	if a=4 : goto *nsfply
	if a=5 {
		wat+=1-((wat=1)*2) : if wat=0 { objprm 5,"off" } else { objprm 5,"on" }
		if wat=1 : fxtget tso,fpath : fxtget tsbk,fpath
		}
	goto *main
;----------------------
*f_lod
	wat=0 : objprm 5,"off" : wait 2
	dialog "mml;*.txt;*.mck;*,mus",16,"mml source"
	if stat=0 : goto *main
	fpath=refstr : getpath fnam,fpath,8+1 : getpath mpath,fpath,32
	mml="" : notesel mml : noteload fpath
	title fpath : wat=1 : objprm 5,"on"
	objprm 0,mml : wait 2
	fxtget tso,fpath : fxtget tsbk,fpath
	goto *main
;----------------------
*f_sav
	notesel mml : notesave fpath
	title fpath : wait 2 : goto *main
;----------------------
*f_cmp
	fxtget tso,fpath : fxtget tsbk,fpath

	chdir exedir+"\\mck"
	exist fnam+".nsf" : if strsize!=-1 : delete fnam+".nsf" : wait 2
	exist fnam+".h"   : if strsize!=-1 : delete fnam+".h" : wait 2
	exist "error.txt" : if strsize!=-1 : delete "error.txt" : wait 2
	exist "errkc.txt" : if strsize!=-1 : delete "errkc.txt" : wait 2
	exist "errlog.txt" : if strsize!=-1 : delete "errlog.txt" : wait 2
	exist "nesasm.exe"
	if strsize=-1 {
		dialog "nesasm.exe not found!",1,"error"
		chdir ".." : goto *main
		}

	if en=0 { exist "mckc.exe" } else { exist "mckc_e.exe" }
	if strsize=-1 {
		dialog "mckc(_e).exe not found!",1,"error"
		chdir ".." : goto *main
		}

; compile of mckc
	mkbat=""
	if en=0 { cprm="mckc" } else { cprm="mckc_e" }
	cprm+=".exe -i \""+fpath+"\" "+fnam+".h"
	pipeexec mkbat,cprm
	repeat : pipeget dmy : if stat=0 : break
	wait 5 : loop
	notesel mkbat : notesave "errkc.txt"

; compile of nesasm
	exec "nesasm.exe -raw make_nsf.txt >> error.txt",2
	wait 30 : a=0 : repeat
	exist "error.txt" : if strsize!=-1 : break
	a++ : title ""+a : if a>100 : break
	wait 20 : loop

	exist "make_nsf.nes" : if strsize!=-1 {
		bcopy "make_nsf.nes",mpath+fnam+".nsf"
		delete "make_nsf.nes"
		delete fnam+".h"
		}
	chdir ".."

; autoplay
	exist mpath+fnam+".nsf" : if strsize!=-1 : goto *nsfply
	wait 10 : goto *main

; -------------------------------
*nsfply
	exec mpath+fnam+".nsf",16
	goto *main
