; mckwatch
;				build 2005/03/27
; ----------------------------------------------
; INCLUDE EXPAND COMMANDS
; ----------------------------------------------

	#include "hspext.as"
	#include "llmod.as"
	#include "obj.as"
	#include "dragdrop.as"

; ----------------------------------------------
; VERSION INFORMATION
; ----------------------------------------------

	ver="MCKwatch - build050327"
	title ver

; ----------------------------------------------
; VALIABLE INITIALIZE
; ----------------------------------------------

	sdim mml,32700
	sdim fname,128
	sdim ddname,128
	sdim fpath,512
	sdim ddpath,512
	sdim tmp,4096
	dim wsiz,8
	dim tms,24
	dim bktms,24

; ----------------------------------------------
; INIFILE LOAD
; ----------------------------------------------
	;wsiz=,c,XW,YW,,ϊmck,t
	wsiz=600,300,0,0,0,1,0 : cmpmode=1
	exist exedir+"\\mckw_cfg.ini"
	if strsize!=-1 {
		bload exedir+"\\mckw_cfg.ini",wsiz
		lang=wsiz.4 : cmpmode=wsiz.5 : plyr=wsiz.6
	}

; ----------------------------------------------
; WINDOW INITIALIZE (resize mode)
; ----------------------------------------------
	screen 0,dispx,dispy,2,wsiz.2,wsiz.3 : cls 1
	objmode 2,1 : font "Arial",12 : objsize 60,20
	mref bmscr, 67
	prm = bmscr.13, -16
	dllproc "GetWindowLongA", prm, 2 ,D_USER
	prm.2 = dllret | 0x50000
	dllproc "SetWindowLongA", prm, 3, D_USER
	width wsiz.0,wsiz.1,wsiz.2,wsiz.3

; ----------------------------------------------
; WINDOW OBJECT SET
; ----------------------------------------------

	pos 000,030 : mesbox mml,winx,winy-30,5,32700	;#0 MML\̈
	pos 005,005 : button "off",*btn			;#1 Ď[h
	pos 080,005 : button "load",*btn		;#2 t@C[h
	pos 140,005 : button "save",*btn		;#3 t@CZ[u
	pos 200,005 : button "errlog",*btn		;#4 G[Oďo
	pos 300,005 : button "[ eng ]",*btn		;#5 
	pos 360,005 : button "mck",*btn			;#6 RpC
	pos 420,005 : button "no-play",*btn		;#7 t
	gsel 0,1 : onexit *p_end
	wait 1 : a=5 : b=1 : gosub *btn2 : b=0
	dd_accept tmp,c,0
; ----------------------------------------------
; MAIN ROUTINE
; ----------------------------------------------
*main
	; EBhETCYωmF
	if (winx!=bkx)|(winy!=bky) {
		wsiz=winx,winy-30,0,30 : bkx=winx : bky=winy
		resizeobj 0,wsiz : objsel 0
	}

	; ^CX^vXVmF
	if (wat=1) {
		fxtget tms,fpath : b=0 : repeat 8 : a=cnt+8
		if (tms.a!=bktms.a) : b=1
		loop
		if b=1 : goto *compil
		b=0
	}

	; hbvt@CmF
	if c>0 : goto *ddrop

	; V[gJbgL[mF

	wait 3 : goto *main

; ----------------------------------------------
; PROGRAM END
; ----------------------------------------------
*p_end
	ginfo 2 : wsiz=winx+2,winy+2,prmx,prmy,lang,cmpmode,plyr
	bsave exedir+"\\mckw_cfg.ini",wsiz
	end

; ----------------------------------------------
; BUTTON TRIGGER
; ----------------------------------------------
*btn
	a=stat : b=0
*btn2
	if a=1 {
		if (b=0) {
			wat++ : if wat>1 : wat=0
		} else { a=5 }
		if wat=0 : objprm 1,"off"
		if wat=1 : objprm 1,"watch"
		if (wat=1)&(fname="") : wat=0 : objprm 1,"off"
		if wat=1 : fxtget tms,fpath
		}
	if a=2 : gosub *F_LD1
	if a=3 : gosub *F_SAV
	if a=4 {
		exist exedir+"\\mck\\errlog.txt"
		if strsize!=-1 : exec exedir+"\\mck\\errlog.txt",16
		}
	if a=5 {
		if (b=0) {
			lang++ : if lang>1 : lang=0
			} else { a=6 }
		if lang=0 : objprm 5,"eng" : font "Arial"
		if lang=1 : objprm 5,"jpn" : font "lr SVbN"
		clrobj 0,0
		pos 000,030 : mesbox mml,winx,winy-30,5,32700
		}
	if a=6 {
		if (b=0) {
;			cmpmode++ : if cmpmode>2 : cmpmode=0
			cmpmode=1
			} else { a=7 }
		if cmpmode=0 : objprm 6,"mck"
		if cmpmode=1 : objprm 6,"ppmck"
		if cmpmode=2 : objprm 6,"hes"
		}
	if a=7 {
		if (b=0) {
			plyr++ : if plyr>3 : plyr=0
			}
		if plyr=0 : objprm 7,"no-play"
		if plyr=1 : objprm 7,"d-click"
		if plyr=2 : objprm 7,"VirtuaNSF"
		if plyr=3 : objprm 7,"G-NSF"
		}
	if b=1 : return
	objsel 0 : goto *main
; ----------------------------------------------
; DRAG & DROP CHECKSUM
; ----------------------------------------------
*ddrop
	if (c!=1) {
		dialog "hbvł̂͂Pt@Ĉ݂ł.",1,"ERROR" : c=0
		goto *main
	}

	notesel tmp : noteget ddpath,0 : c=0
	getpath tmp,ddpath,2 : charupper tmp
	if (tmp!=".MML")&(tmp!=".MCK")&(tmp!=".MUS") {
		dialog "Ήt@Cł.",1,"ERROR" : goto *main
	}

	fpath=ddpath : getpath fname,ddpath,9
	gosub *F_LD2
	goto *main

; ----------------------------------------------
; FILE LOAD
; ----------------------------------------------
*F_LD1
	wat=0 : objprm 0,"off"
	dialog "mml;*.mck;*.mus",16,"MML source file"
	if stat=0 : return
	fpath=refstr : getpath fname,refstr,9

*F_LD2
	strlen a,mml if a>0 {
		repeat a : poke mml,cnt,$00 : loop
		}
	bload fpath,mml
	objprm 0,mml : wat=1
	title ver+" - "+fname
	fxtget tms,fpath : fxtget bktms,fpath
	a=1 : b=1 : gosub *btn2 : b=0
	return

; ----------------------------------------------
; FILE SAVE
; ----------------------------------------------
*F_SAV
	if fpath="" {
		dialog "mml",17,"Save mml source"
		if stat=0 : return

		notesel mml : notesave refstr
		fpath=refstr : getpath fname,fpath,9
		fxtget bktms : fxtget tms
	} else {
		notesel mml : notesave fpath
	}
	return

; ----------------------------------------------
; COMPILE ENGINE
; ----------------------------------------------
*compil
	if fpath="" {
		dialog "Found invalid compile jump.\nsȓm܂.",1,"ERROR" : end
	}

	dd_reject 0,0
	fxtget tms,fpath : fxtget bktms,fpath
	getpath ddpath,fpath,32

; delete temp file
	exist exedir+"\\makensf.bat"
	if strsize!=-1 : delete exedir+"\\makensf.bat"
	exist exedir+"\\mck\\errlog.txt"
	if strsize!=-1 : delete exedir+"\\mck\\errlog.txt"
	exist exedir+"\\mck\\errlog2.txt"
	if strsize!=-1 : delete exedir+"\\mck\\errlog2.txt"
	exist ddpath+fname+".nsf"
	if strsize!=-1 : delete ddpath+fname+".nsf"

	wait 5

; batchfile for ppmck
	tmp=""
	tmp+="@echo off\ncd "+ddpath+"\n"
	tmp+="SET NES_INCLUDE="+exedir+"\\mck\\nes_include\n"
	tmp+="if not exist effect.h goto compile\n"
	tmp+="del effect.h\n:compile\n"
	tmp+=exedir+"\\mck\\bin\\ppmckc -i "+ddpath+fname+".mml >> "+exedir+"\\mck\\errlog.txt\n"
	tmp+="if not exist effect.h goto err1\n"
	tmp+="if not exist ppmck.nes goto assemble\n"
	tmp+="del ppmck.nes\n"
	tmp+=":assemble\n"
	tmp+=exedir+"\\mck\\bin\\nesasm -s -raw ppmck.asm >> "+exedir+"\\mck\\errlog.txt\n"
	tmp+="if not exist ppmck.nes goto err2\n"
	tmp+="move ppmck.nes "+ddpath+fname+".nsf\n"
	tmp+="goto finally\n"
	tmp+=":err1\necho ppmckc compile error. > "+exedir+"\\mck\\errlog2.txt\n"
	tmp+="goto finally\n"
	tmp+=":err2\necho nesasm assemble error. > "+exedir+"\\mck\\errlog2.txt\n"
	tmp+="goto finally\n"
	tmp+=":finally"

	strlen a,tmp
	notesel tmp : notesave exedir+"\\makensf.bat"

; batchfile create checksum
	a=0 : b=0
	repeat
	exist exedir+"\\makensf.bat"
	if strsize!=-1 : break
	a++ : if a>100 : b=1 : break
	wait 3 : loop
	if b=1 {
		dialog "ob`t@C쐬ł܂.",1,"ERROR"
		a=0 : b=0 : dd_reject 0,1 : goto *cmpend
	}
	a=0 : b=0
	exec exedir+"\\makensf.bat",1

	repeat
	exist ddpath+fname+".nsf"
	if strsize!=-1 : break
	exist exedir+"\\mck\\errlog2.txt"
	if strsize!=-1 : b=1 : break
	a++ : if a>100 : b=1 : break
	wait 3 : loop
	if b=1 {
		dialog "RpC̓AZuɎs܂.",1,"ERROR"
		a=0 : b=0 : dd_reject 0,1 : goto *cmpend
	}

*cmpend
	exist exedir+"\\makensf.bat"
	if strsize!=-1 : delete exedir+"\\makensf.bat"
	exist exedir+"\\define.inc"
	if strsize!=-1 : delete exedir+"\\define.inc"
	dd_reject 0,1 : a=0 : b=0

; nsf-file playable
	exist ddpath+fname+".nsf"
	if strsize=-1 : goto *main

	if plyr=0 : goto *main
	if plyr=1 : exec ddpath+fname+".nsf",16
	if plyr=2 {
		exist exedir+"\\virtuaNSF.exe"
		if strsize!=-1 : exec exedir+"\\virtuaNSF.exe "+ddpath+fname+".nsf"
		}
	if plyr=3 {
		exist exedir+"\\gnsf.exe"
		if strsize!=-1 :  exec exedir+"\\gnsf.exe "+ddpath+fname+".nsf"
		}
	goto *main
