; --+--+----+--+----+--+----+--+----+--+----+--+----+--+----+--+--
;      MCK-WATCH 2.61 system
;				for Win9x/Me/NT/2000/XP series
; --+--+----+--+----+--+----+--+----+--+----+--+----+--+----+--+--

	#include "hspext.as"
	#include "llmod.as"
	#include "obj.as"
	#include "dragdrop.as"

; ---------- ---------- ---------- ---------- ---------- ----------
; Initialize section
; ---------- ---------- ---------- ---------- ---------- ----------

	ver="MCKwatch2.61 Ver1.0 Lev.45"

	title ver
	sdim mml,32000 : sdim fpath,512 : sdim dpath,512
	sdim temp,2048 : sdim cprm,1024 : sdim ppmsg,2048
	sdim ddpath,512 : sdim ddin,1024
	dim ftms,24 : dim ftbk,24 : dim wsiz,7 : z=0

	chdir exedir

	wsiz=620,300,0,0,0,0
	exist exedir+"\\mckwinit.ini"
	if strsize!=-1 {
		bload exedir+"\\mckwinit.ini",wsiz
		lang=wsiz.4 : plyr=wsiz.5 : lmck=wsiz.6 }

	screen 0,dispx,dispy,2,wsiz.2,wsiz.3 : cls 1
	objmode 2,1 : font "Arial",12 : objsize 60,20
	mref bmscr, 67
	prm = bmscr.13, -16
	dllproc "GetWindowLongA", prm, 2 ,D_USER
	prm.2 = dllret | 0x50000
	dllproc "SetWindowLongA", prm, 3, D_USER
	width wsiz.0,wsiz.1,wsiz.2,wsiz.3

	pos 000,030 : mesbox mml,winx,winy-30,5,32000		;#0
	pos 005,005 : button "sleep",*btn			;#1
	pos 075,005 : button "load",*btn			;#2
	pos 135,005 : button "save",*btn			;#3
	pos 195,005 : button "mckc",*btn			;#4
	pos 255,005 : button "nesasm",*btn			;#5
	pos 325,005 : button "Play",*btn			;#6
	pos 395,005 : chkbox "JPlang",lang			;#7
	pos 455,005 : chkbox "BDT",lmck				;#8
	objsize 90,20
	pos 525,003 : combox plyr,100,"DoubleClick\nVirtuaNSF\nG-NSF"
	gsel 0,1 : onexit *pg_end
	dd_accept ddin,dd,0
	if cmdline!="" {
		ddin=cmdline : dd=1 : goto *ddchk
	}

; ---------- ---------- ---------- ---------- ---------- ----------
; MAIN ROUTINE
; ---------- ---------- ---------- ---------- ---------- ----------
*main
	if dd : goto *ddchk

	if (lmck=0) { rundir=exedir+"\\mck" } else { rundir=exedir+"\\mcklong" }

	if (x!=winx)|(y!=winy) {
		wsiz=winx,winy-30,0,30 : x=winx : y=winy
		resizeobj 0,wsiz : objsel 0 }

	if (wat!=wbk) {
		if wat=1 { objprm 1,"watch" } else { objprm 1,"sleep" }
		wbk=wat : objsel 0
		}

	if (lang!=lgbk) {
		if lang=1 { font "lr SVbN",14 } else { font "Arial",14 }
		clrobj 0,0 : pos 0,30 : mesbox mml,winx,winy-30,5,32000
		lgbk=lang : objsel 0
		}

	if wat=1 {
		fxtget ftms,fpath : a=8 : b=0
		repeat 8 : if (ftms.a!=ftbk.a) : b=1
		a++ : loop : if b=1 : goto *compl
		}

	if z=1 : z=0 : goto *compl

	ginfo 1 : getkey a,17 : getkey b,83 : exist fpath
	if (a=1)&(b=1)&(prmx=0)&(strsize!=-1) : goto *f_sv

	getkey b,112
	if (b=1)&(prmx=0) {
		exist exedir+"\\Mckwuty.exe"
		if strsize>-1 : exec exedir+"\\Mckwuty.exe",0
		}

	getkey b,80
	if (a=1)&(b=1)&(prmx=0) : goto *nsfplay

	getkey a,27 : if (a=1)&(prmx=0) : goto *pg_end

	exist fpath
	if strsize=-1 { objgray 1,0 } else { objgray 1,1 }

	exist rundir+"\\err_mckc.txt"
	if strsize=-1 { objgray 4,0 } else { objgray 4,1 }

	exist rundir+"\\err_nesm.txt"
	if strsize=-1 { objgray 5,0 } else { objgray 5,1 }

	exist dpath+nsfnam+".nsf"
	if strsize=-1 { objgray 6,0 } else { objgray 6,1 }

	wait 3 : goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; BUTTON OPERATION
; ---------- ---------- ---------- ---------- ---------- ----------
*btn
	a=stat
	if a=1 : wat+=1-((wat=1)*2)
	if a=2 : wat=0 : goto *f_ld
	if a=3 : goto *f_sv
	if a=4 : exec rundir+"\\err_mckc.txt",16
	if a=5 : exec rundir+"\\err_nesm.txt",16
	if a=6 : goto *nsfplay
	goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; DRAG & DROP CHECKSUM
; ---------- ---------- ---------- ---------- ---------- ----------
*ddchk
	if dd!=1 {
		if lang=0 : dialog "Not Support multi-files",1,"ERROR"
		if lang=1 : dialog "t@C̑I͂ł܂",1,"ERROR"
		dd=0 : goto *main
	}
	notesel ddin : noteget ddpath,0
	dd=0 : fpath=ddpath : charupper fpath : getpath cprm,fpath,2
	if (cprm!=".MML")&(cprm!=".MUS")&(cprm!=".MCK") {
		if lang=0 : dialog "Not support.\n.mml / .mck / .mus type.",1,"ERROR"
		if lang=1 : dialog "T|[gĂȂ`ł.\n.mml / .mck / .mus ̂݉\ł.",1,"ERROR"
		dd=0 : goto *main
	}
	fpath=ddpath
	goto *f_ld2

; ---------- ---------- ---------- ---------- ---------- ----------
; FILE SAVE / LOAD
; ---------- ---------- ---------- ---------- ---------- ----------
*f_sv
	if (fpath="")|(fnam="") {
		fnam="songdata.mml" : fpath=exedir+"\\"+fnam : z=1 : wat=1
		}
	title "overwrite "+fpath
	notesel mml : notesave fpath
	wait 50 : title ver+" - "+fnam
	if z=1 : goto *f_ld2
	goto *main
*f_ld
	dialog "mml;*.mck;*.mus",16,"MML SOURCE"
	if stat=0 : goto *main
	fpath=refstr
*f_ld2
	mml="" : dpath="" : fnam="" : nsfnam=""
	notesel mml : noteload fpath : objprm 0,mml : wait 1
	getpath fnam,fpath,8 : getpath nsfnam,fpath,9
	getpath dpath,fpath,32

	a=0 : strlen b,nsfnam
	repeat b : strmid cprm,nsfnam,cnt,1 : if cprm="-" : a=1
	loop : if a=1 {
		if lang=0 : dialog "Don't use - character in filename.",1,"WARNING"
		if lang=1 : dialog "- (nCt) ̓t@CɎg܂.",1,"WARNING"
		mml="" : fpath="" : dpath="" : fnam="" : nsfnam="" : objprm 0,""
		wat=0 : title ver : goto *main
	}
	fxtget ftms,fpath : fxtget ftbk,fpath
	wat=1 : title ver+" - "+fnam
	goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; CALL PLAYER
; ---------- ---------- ---------- ---------- ---------- ----------
*nsfplay

	if plyr=1 : exist exedir+"\\VirtuaNSF.exe"
	if plyr=2 : exist exedir+"\\GNSF.exe"
	if strsize=-1 {
		if lang=0 : dialog "Player exec not found.",1,"ERROR"
		if lang=1 : dialog "tvC[܂.",1,"ERROR"
		goto *main }
	exist dpath+nsfnam+".nsf"
	if strsize=-1 {
		if lang=0 : dialog "NSF-FILE NOT FOUND.",1,"ERROR"
		if lang=1 : dialog "NSFt@C܂.",1,"ERROR"
		goto *main }
	if plyr=0 : exec dpath+nsfnam+".nsf",16
	if plyr=1 : exec exedir+"\\VirtuaNSF.exe \""+dpath+nsfnam+".nsf\"",0
	if plyr=2 : exec exedir+"\\GNSF.exe \""+dpath+nsfnam+".nsf\"",0

	repeat : stick a,1,0 : if a=0 : break
	wait 5 : loop
	goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; PROGRAM ESCAPE (INI GENERATE)
; ---------- ---------- ---------- ---------- ---------- ----------
*pg_end
	dd_reject 0,0
	ginfo 2 : wsiz=winx+2,winy+2,prmx,prmy,lang,plyr,lmck
	bsave exedir+"\\mckwinit.ini",wsiz
	end

; ---------- ---------- ---------- ---------- ---------- ----------
; COMPILE ROUTINE
; ---------- ---------- ---------- ---------- ---------- ----------
*compl
	dd_reject 0,0
	fxtget ftbk,fpath : fxtget ftms,fpath
	title "Delete old files."
	repeat 8 : objgray cnt+1,0 : loop

	cprm="" : chdir exedir
	if lmck=0 { dirlist cprm,"mck",5 } else { dirlist cprm,"mcklong",5 }
	notesel cprm : noteget cprm,0
	if cprm="" {
		if lang=0 : dialog "running directory not found.",1,"ERROR"
		if lang=1 : dialog "ϊtH_܂.",1,"ERROR"
		goto *escap
	}

	chdir rundir
	exist "err_mckc.txt" : if strsize!=-1 : delete "err_mckc.txt"
	exist "err_nesm.txt" : if strsize!=-1 : delete "err_nesm.txt"
	exist dpath+nsfnam+".nsf" : if strsize!=-1 : delete dpath+nsfnam+".nsf"
	exist nsfnam+".nsf" : if strsize!=-1 : delete nsfnam+".nsf"
	exist nsfnam+".h" : if strsize!=-1 : delete nsfnam+".h"
	wait 15

	title "Program Check."
	exist "nesasm.exe"
	if strsize=-1 {
		if lang=0 : dialog "nesasm.exe not found.",1,"ERROR"
		if lang=1 : dialog "nesasm.exe ܂.",1,"ERROR"
		goto *escap
		}

	exist "mckc.exe"
	if strsize=-1 {
		if lang=0 : dialog "mckc.exe not found.",1,"ERROR"
		if lang=1 : dialog "mckc.exe ܂.",1,"ERROR"
		goto *escap
		}

	exist "make_nsf.txt"
	if strsize=-1 {
		if lang=0 : dialog "mck system broken.",1,"ERROR"
		if lang=1 : dialog "mck ɕKvȃZbgĂ܂.",1,"ERROR"
		goto *escap
		}
	wait 15

;  MCKC compile routine
; ----------------------
	temp="" : ppmsg="" : a=0 : b=0
	cprm="mckc.exe -i \""+fpath+"\" "+nsfnam+".h"
	pipeexec temp,cprm
	repeat : pipeget ppmsg : if stat=0 : break
	title "MCKC compile running. [ "+a+" / 1600 ]"
	a++ : if a>1600 : b=1 : break
	wait 20 : loop
	notesel temp : notesave "err_mckc.txt"
	if b=1 {
		if lang=0 : dialog "loop count overflow.",1,"WARNING."
		if lang=1 : dialog "EFCgɒB܂.\n𒆎~܂.",1,"WARNING"
		goto *escap
	}
	wait 20
	exist "effect.h"
	if strsize=-1 {
		if lang=0 : dialog "mckc compile abort.",1,"ERROR"
		if lang=1 : dialog "mckc ̃RpCɎs܂.",1,"ERROR"
		exec exedir+"\\mck\\err_mckc.txt",16
		goto *escap
	}

;  NESASM compile routine
; ------------------------
	exec "nesasm.exe -raw make_nsf.txt >> err_nesm.txt",2
	wait 30 : a=0 : b=0
	repeat
	title "NESASM compile running.[ "+a+" / 1600 ]"
	exist "err_nesm.txt" : if strsize!=-1 : break
	a++ : if a>1600 : b=1 : break
	wait 20 : loop
	if b=1 {
		if lang=0 : dialog "loop count overflow.",1,"WARNING."
		if lang=1 : dialog "EFCgɒB܂.\n𒆎~܂.",1,"WARNING"
		goto *escap
	}
	wait 60

;  nes file copy
; ---------------
	a=0 : b=0 : repeat
	exist "make_nsf.nes" : if strsize!=-1 : break
	wait 20 : a++ : if a>500 : b=1 : break
	loop
	if b=1 {
		if lang=0 : dialog "nsf-tune generate error.",1,"ERROR"
		if lang=1 : dialog "NSFt@CȂ肪܂.",1,"ERROR"
		exec rundir+"\\err_nesm.txt",16
		goto *escap
	}

	bcopy "make_nsf.nes",dpath+nsfnam+".nsf"
	delete "make_nsf.nes"
	delete nsfnam+".h"
	wait 20

	a=0 : repeat : exist dpath+nsfnam+".nsf"
	if strsize!=-1 : break
	a++ : if a>1000 : break
	loop : b=2

*escap
	chdir exedir : title ver+" - "+fnam : dd_reject 0,1
	a=0 : repeat 8 : objgray cnt+1,1 : loop
	if b=2 : goto *nsfplay
	goto *main
